import { IReducer, IDispatch, UpdateState, IModuleConfig, IActionMap } from './Types';
export declare class State {
    constructor(config: IModuleConfig);
    /**
     * adding reducer to array
     * @param reducer
     */
    addReducer(reducer: IReducer<any>): void;
    /**
     * adding actions to array
     * @param action
     */
    addActions(types: string[], metaData: IActionMap): void;
    /**
     * sending payload to reducer method with payload if any
     * @param action
     */
    sendAction<T>(data: IDispatch<T>): void;
    /**
     * updating State
     * @param input
     */
    updatedState(input: UpdateState<any>): void;
    /**
     * sending whole state
     */
    getState<T>(): T;
    /**
     * sending get and update state object to reducer
     */
    private readonly getStateObject;
    private intializeState(key, payload);
}
